Summary: Version 2.x of the Berkeley DB
Name: db
Version: 2.7.7
Release: 1
Source: http://www.sleepycat.com/update/2.7.7/db-2.7.7.tar.gz
Url: http://www.sleepycat.com/
Group: Libraries
Packager: David MacKenzie <djm@web.us.uu.net>
BuildRoot: /tmp/db-root
Copyright: Freely redistributeable (BSD License, w/ advertising clause, many copyright holders).
Vendor: Sleepycat Software

%description
An embedded database system.  Berkeley DB is a programmatic
toolkit that provides high-performance built-in database support for
desktop and server applications and for information appliances.

The Berkeley DB access methods include B+tree, Extended Linear Hashing,
Fixed and Variable-length records, and Queues.  Berkeley DB provides full
transactional support, database recovery, online backups, and separate
access to locking, logging and shared memory caching subsystems.

Berkeley DB supports C, C++, Java, Tcl and Perl APIs. 

This package replaces several files from glibc, which comes with a version
of Berkeley DB compiled without C++ support, so you must use rpm --force
to install it.

%package devel
Requires: db
Summary: Development headers and libraries for Berkeley DB 2.x
Group: Development/Libraries

%description devel
This package contains the include files and the library required
for Berkeley DB 2.x development.

This package replaces several files from glibc, which comes with a version
of Berkeley DB compiled without C++ support, so you must use rpm --force
to install it.

%prep
%setup 

%build
cd build_unix
# Remove bogus option set by Linux-Mandrake 7.0:
COPTS="-g -fpic `echo ${RPM_OPT_FLAGS}|sed 's,-fno-exceptions,,'`"
CFLAGS="$COPTS" CXXFLAGS="$COPTS" \
  ../dist/configure --prefix=${RPM_BUILD_ROOT}/usr --enable-cxx
make
# Build a shared library.
# We add -lstdc++ so we can link C programs normally, without getting:
# $ cc foo.c -o foo -ldb 
# /usr/bin/../lib/libdb.so: undefined reference to `ostream::operator<<(char const *)'
test -d shared || mkdir shared
cd shared
rm -f *.o
ar xv ../libdb.a
cc -shared -o libdb.so.${RPM_PACKAGE_VERSION} *.o -lstdc++
mv libdb.so.${RPM_PACKAGE_VERSION} ..

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/lib
cd build_unix
make install bindir=$RPM_BUILD_ROOT/usr/bin datadir=$RPM_BUILD_ROOT/usr/share includedir=$RPM_BUILD_ROOT/usr/include libdir=$RPM_BUILD_ROOT/usr/lib mandir=$RPM_BUILD_ROOT/usr/share/db
cp libdb.so.${RPM_PACKAGE_VERSION} ${RPM_BUILD_ROOT}/lib
ln -sf libdb.so.${RPM_PACKAGE_VERSION} ${RPM_BUILD_ROOT}/lib/libdb.so.3
ln -sf ../../lib/libdb.so.3 ${RPM_BUILD_ROOT}/usr/lib/libdb.so

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc LICENSE README
%doc /usr/share/db/packages
%doc /usr/share/db/sleepycat
%doc /usr/share/db/utility
/usr/bin/db_archive
/usr/bin/db_checkpoint
/usr/bin/db_deadlock
/usr/bin/db_dump
/usr/bin/db_load
/usr/bin/db_printlog
/usr/bin/db_recover
/usr/bin/db_stat
/lib/libdb.so.%{PACKAGE_VERSION}
/lib/libdb.so.3

%files devel
%defattr(-,root,root)
%doc examples examples_cxx examples_java
%doc /usr/share/db/api_c
%doc /usr/share/db/api_cxx
%doc /usr/share/db/api_java
%doc /usr/share/db/build
%doc /usr/share/db/distrib
%doc /usr/share/db/images
%doc /usr/share/db/ref
/usr/include/db.h
/usr/include/db_185.h
/usr/include/db_cxx.h
/usr/lib/libdb.a
/usr/lib/libdb.so
